# 2.15.x Release Series

## 2.15.0rc1 (Dec 26, 2022)

### Bug fixes

* scala: support scala v3 which has different compiler/library artifacts (Cherry pick of #17855) ([#17866](https://github.com/pantsbuild/pants/pull/17866))

* Restore support for :all: in only_binary/no_binary. (Cherry-pick of #17779) ([#17784](https://github.com/pantsbuild/pants/pull/17784))

* Test DebugAdapter requests, and fix issues (Cherry-pick of #17678) ([#17768](https://github.com/pantsbuild/pants/pull/17768))

* chdir in `rule_runner.run_interactive_process` (Cherry-pick of #17722) ([#17765](https://github.com/pantsbuild/pants/pull/17765))

### Performance

* Run python sources with a VenvPex (Cherry-pick of #17700) ([#17761](https://github.com/pantsbuild/pants/pull/17761))

### Documentation

* Document batched `pytest` execution. (Cherry-pick of #17845) ([#17853](https://github.com/pantsbuild/pants/pull/17853))

* Tweak the docs about __defaults__. (Cherry-pick of #17829) ([#17838](https://github.com/pantsbuild/pants/pull/17838))

## 2.15.0rc0 (Dec 08, 2022)

### Bug fixes

* More precise running workunit for processes executing remotely (Cherry-pick of #17719) ([#17725](https://github.com/pantsbuild/pants/pull/17725))

* Fix twine env vars propagation for `publish` goal. (Cherry-pick of #17650) ([#17659](https://github.com/pantsbuild/pants/pull/17659))

* Allow for `run --debug-adapter` to match breakpoints when source is running in a sandbox (Cherry-pick of #17566) ([#17584](https://github.com/pantsbuild/pants/pull/17584))

* Do not try to create `""` output directory in `CreateArchive` (Cherry-pick of #17538) ([#17548](https://github.com/pantsbuild/pants/pull/17548))

### Documentation

* Fix broken docs links to manual build instructions (Cherry-pick of #17608) ([#17610](https://github.com/pantsbuild/pants/pull/17610))

* Update team pages for SJ and Dan! (Cherry-pick of #17534) ([#17568](https://github.com/pantsbuild/pants/pull/17568))

* Add Shantanu Kumar to Contributors list (Cherry-pick of #17579) ([#17587](https://github.com/pantsbuild/pants/pull/17587))

## 2.15.0a1 (Nov 11, 2022)

### New Features

* A --resolve flag, to specify the resolves to export. (Cherry-pick of #17416) ([#17461](https://github.com/pantsbuild/pants/pull/17461))

### User API Changes

* Deprecate the old export semantics. (Cherry-pick of #17465) ([#17466](https://github.com/pantsbuild/pants/pull/17466))

### Bug fixes

* Fix memoization of `CoarsenedTarget.closure` (Cherry-pick of #17516) ([#17518](https://github.com/pantsbuild/pants/pull/17518))

* Support parsing targets from additional paths not containing BUILD files. (Cherry-pick of #17451) ([#17513](https://github.com/pantsbuild/pants/pull/17513))

* Ensure lockfile target exists before injecting a dependency to it. (Cherry-pick of #17365) ([#17505](https://github.com/pantsbuild/pants/pull/17505))

* Ensure correct eq/hash semantics for PythonArtifact. (Cherry-pick of #17484) ([#17492](https://github.com/pantsbuild/pants/pull/17492))

* Flip the default for `pull` on `docker_image` to `False` (Cherry-pick of #17459) ([#17460](https://github.com/pantsbuild/pants/pull/17460))

* Isolate config seed values from the DEFAULT section. (Cherry-pick of #17474) ([#17485](https://github.com/pantsbuild/pants/pull/17485))

* Fix poorly understood stdout redirection issue. (Cherry-pick of #17471) ([#17473](https://github.com/pantsbuild/pants/pull/17473))

* Fix propagation of the remote-execution-append-only-caches path  (Cherry-pick of #17469) ([#17472](https://github.com/pantsbuild/pants/pull/17472))

* Fix dep inference from `shuint2_tests` targets. (Cherry-pick of #17417) ([#17422](https://github.com/pantsbuild/pants/pull/17422))

* Fix `EnvironmentName` used in `test` runs (Cherry-pick of #17412) ([#17415](https://github.com/pantsbuild/pants/pull/17415))

* Restore debug hints for `test` execution (Cherry-pick of #17406) ([#17407](https://github.com/pantsbuild/pants/pull/17407))

### Performance

* Skip loading of local cache data when possible (Cherry-pick of #17495) ([#17524](https://github.com/pantsbuild/pants/pull/17524))

* Symlink site-packages into `pylint` venvs when possible. (Cherry-pick of #17488) ([#17491](https://github.com/pantsbuild/pants/pull/17491))

* Filter coarsened targets to only those that are relevant in `pylint` runner rule (Cherry-pick of #17487) ([#17490](https://github.com/pantsbuild/pants/pull/17490))

### Documentation

* Fix line breaks in a docs page. (Cherry-pick of #17527) ([#17528](https://github.com/pantsbuild/pants/pull/17528))

* Clarify how `__defaults__` apply to target generators. (Cherry-pick of #17493) ([#17499](https://github.com/pantsbuild/pants/pull/17499))

* Fix version templating in `vcs_version` docs (Cherry-pick of #17423) ([#17425](https://github.com/pantsbuild/pants/pull/17425))

## 2.15.0a0 (Oct 28, 2022)

### New Features

* Add support for batched `pytest` execution ([#17385](https://github.com/pantsbuild/pants/pull/17385))

* Add a `batch_size` parameter to the `test` subsystem. ([#17361](https://github.com/pantsbuild/pants/pull/17361))

* Replace `skip` placeholders with real `SkipOption`s in test subsystems. ([#17360](https://github.com/pantsbuild/pants/pull/17360))

### Plugin API Changes

* Refactor optional typing in generic partitioning utils. ([#17371](https://github.com/pantsbuild/pants/pull/17371))

* Refactor plumbing for `test` goal to support batched tests. ([#17134](https://github.com/pantsbuild/pants/pull/17134))

* Rework partitioning types for more flexibility. ([#17288](https://github.com/pantsbuild/pants/pull/17288))

### Bug fixes

* Ensure PATH to shims are absolute for the protobuf buf linter. ([#17367](https://github.com/pantsbuild/pants/pull/17367))

* Include process execution strategy in Process cache key ([#17340](https://github.com/pantsbuild/pants/pull/17340))

* Fix use of `--shard` with `--debug`/`--debug-adapter` in `test`. ([#17321](https://github.com/pantsbuild/pants/pull/17321))

* go: properly handle xtest packages when building ([#17307](https://github.com/pantsbuild/pants/pull/17307))

* Retry the streaming portion of downloads, as well as the setup. ([#17298](https://github.com/pantsbuild/pants/pull/17298))

### Performance

* Implement cancellation of remote processes ([#17341](https://github.com/pantsbuild/pants/pull/17341))

### Documentation

* Document Synthetic Targets API.([#17330](https://github.com/pantsbuild/pants/pull/17330))

* Initial documentation for Environments ([#17096](https://github.com/pantsbuild/pants/pull/17096))

* Add 2.14 blog post link to changelog page. ([#17381](https://github.com/pantsbuild/pants/pull/17381))

* Document the existence of the init-pants action. ([#17378](https://github.com/pantsbuild/pants/pull/17378))

* Add a section about `test` to plugin API guide. ([#17362](https://github.com/pantsbuild/pants/pull/17362))

* Revise the error message associated with OOM-killed events ([#17373](https://github.com/pantsbuild/pants/pull/17373))

* Fix linebreak issues in the targets docs page. ([#17364](https://github.com/pantsbuild/pants/pull/17364))

* Fix a nit in the Getting Help docs. ([#17295](https://github.com/pantsbuild/pants/pull/17295))

## 2.15.0.dev5 (Oct 19, 2022)

### New Features

* Synthesize targets for Python lockfiles ([#17097](https://github.com/pantsbuild/pants/pull/17097))

* Refactor `shunit2` into a proper subsystem. ([#17257](https://github.com/pantsbuild/pants/pull/17257))

* Add lcov support ([#17256](https://github.com/pantsbuild/pants/pull/17256))

* New API to create synthetic targets. ([#16998](https://github.com/pantsbuild/pants/pull/16998))

* Support custom post renderers in Helm deployments ([#17215](https://github.com/pantsbuild/pants/pull/17215))

* Add a `fix` goal ([#17202](https://github.com/pantsbuild/pants/pull/17202))

* Add basic support for pyright typechecking ([#17163](https://github.com/pantsbuild/pants/pull/17163))

### User API Changes

* Upgrade Pex to 2.1.111. ([#17267](https://github.com/pantsbuild/pants/pull/17267))

* Upgrade the Pants-provided `coverage`  to version 6.5.X ([#17254](https://github.com/pantsbuild/pants/pull/17254))

* Upgrade default Flake8 version to 5.0 ([#17226](https://github.com/pantsbuild/pants/pull/17226))

* Add Snowflake connector to module mapping ([#17165](https://github.com/pantsbuild/pants/pull/17165))

* Always include relevant params in workunit descriptions, and include descriptions in traces by default ([#17119](https://github.com/pantsbuild/pants/pull/17119))

### Plugin API Changes

* Rename `SubPartition` to `Batch` in partitioning types. ([#17263](https://github.com/pantsbuild/pants/pull/17263))

* Make fmt/lint result types less boilerplate-y ([#17192](https://github.com/pantsbuild/pants/pull/17192))

* Begin migration to explicitly scoped environments ([#17155](https://github.com/pantsbuild/pants/pull/17155))

### Bug fixes

* Fix remote execution not working with remote caching and eager fetch mode ([#17272](https://github.com/pantsbuild/pants/pull/17272))

* Remote cache reads are resilient to remote execution writing to the cache ([#17195](https://github.com/pantsbuild/pants/pull/17195))

* Adjust `ensure_remote_has_recursive` to succeed if content only exists remotely ([#17204](https://github.com/pantsbuild/pants/pull/17204))

* Declaring Javascript, Prettier, and Pyright backends/plugins in BUILD ([#17190](https://github.com/pantsbuild/pants/pull/17190))

* Set PEX_ROOT for export post-processing command. ([#17177](https://github.com/pantsbuild/pants/pull/17177))

* Fix macros depending on macros from other files ([#17183](https://github.com/pantsbuild/pants/pull/17183))

* go/gofmt: filter out non-go files from file list ([#17171](https://github.com/pantsbuild/pants/pull/17171))

* Fix dep inference with empty lines in multiline imports. ([#17284](https://github.com/pantsbuild/pants/pull/17284))

### Documentation

* Change fmt/lint/check docs with latest changes ([#17133](https://github.com/pantsbuild/pants/pull/17133))

* Add CI talk to resources ([#17238](https://github.com/pantsbuild/pants/pull/17238))

## 2.15.0.dev4 (Oct 07, 2022)

### New Features

* Optionally export venvs via symlink into the pex_root. ([#17130](https://github.com/pantsbuild/pants/pull/17130))

* go: add cgo support for tailor ([#17087](https://github.com/pantsbuild/pants/pull/17087))

### User API Changes

* Upgrade Pex to 2.1.108. ([#17112](https://github.com/pantsbuild/pants/pull/17112))

### Plugin API Changes

* Switch `LintRequest.name` to `.tool_subsystem` ([#17103](https://github.com/pantsbuild/pants/pull/17103))

* Rename/Refactor `style_request` to better capture intent. ([#17084](https://github.com/pantsbuild/pants/pull/17084))

### Bug fixes

* [internal] Move pyoxidized pants binary out of the main source tree ([#16703](https://github.com/pantsbuild/pants/pull/16703))

### Documentation

* Generate help info about target_field_name to the docsite. ([#17138](https://github.com/pantsbuild/pants/pull/17138))

* Add Aiven to user list. ([#17131](https://github.com/pantsbuild/pants/pull/17131))

* Fix `bsp-groups.toml` example in documentation ([#17125](https://github.com/pantsbuild/pants/pull/17125))

* Update maintainer job description ([#17022](https://github.com/pantsbuild/pants/pull/17022))

## 2.15.0.dev3 (Oct 03, 2022)

### New Features

* Add `venv_site_packages_copies` field to `pex_binary` ([#17046](https://github.com/pantsbuild/pants/pull/17046))

* Add golangci-lint to go backend ([#16994](https://github.com/pantsbuild/pants/pull/16994))

* go: add `go-generate` goal to run `go generate` on a package ([#16909](https://github.com/pantsbuild/pants/pull/16909))

* Support Java codegen for the OpenAPI backend ([#16862](https://github.com/pantsbuild/pants/pull/16862))

* go: render coverage reports as HTML ([#16995](https://github.com/pantsbuild/pants/pull/16995))

* Environment-aware subsystems ([#16965](https://github.com/pantsbuild/pants/pull/16965))

* Environment sensitive options ([#16840](https://github.com/pantsbuild/pants/pull/16840))

* Add retries to NetDownload intrinsic. ([#16798](https://github.com/pantsbuild/pants/pull/16798))

* go: add basic support for cgo ([#16413](https://github.com/pantsbuild/pants/pull/16413))

* Add support for add-trailing-comma tool ([#16776](https://github.com/pantsbuild/pants/pull/16776))

### User API Changes

* Upgrade Pex to 2.1.107. ([#17081](https://github.com/pantsbuild/pants/pull/17081))

* Restore the deprecated `filter` goal indefinitely ([#17027](https://github.com/pantsbuild/pants/pull/17027))

### Plugin API Changes

* Improve usability of the `--engine-visualize-to` option ([#17080](https://github.com/pantsbuild/pants/pull/17080))

* Change `fmt` plugin schema to allow for targetless formatters ([#16980](https://github.com/pantsbuild/pants/pull/16980))

* Renames `SubsystemRule()` to `Subsystem.rules()` ([#16954](https://github.com/pantsbuild/pants/pull/16954))

* Introduce new schema for lint plugins ([#16735](https://github.com/pantsbuild/pants/pull/16735))

* `Environment`, `EnvironmentRequest`, and `CompleteEnvironment` now include `Vars` in the name ([#16851](https://github.com/pantsbuild/pants/pull/16851))

* `MockGet` expects `input_types` kwarg, not `input_type` ([#16839](https://github.com/pantsbuild/pants/pull/16839))

### Bug fixes

* Fix dirtying of uncacheable nodes ([#17079](https://github.com/pantsbuild/pants/pull/17079))

* Make interpreter path expansion cache-correct ([#17051](https://github.com/pantsbuild/pants/pull/17051))

* Add python 3.10 to acceptable GCF runtimes ([#17028](https://github.com/pantsbuild/pants/pull/17028))

* Don't cache VCS version outside the current pants session. ([#17017](https://github.com/pantsbuild/pants/pull/17017))

* Fix Pantsd not properly invalidating when `CPPFLAGS` and `LDFLAGS` change ([#17009](https://github.com/pantsbuild/pants/pull/17009))

* Add `parametrize()` support for `__defaults__`. ([#16977](https://github.com/pantsbuild/pants/pull/16977))

* go: prepend $GOROOT/bin to PATH for tests ([#16993](https://github.com/pantsbuild/pants/pull/16993))

* Fix for hang with redirected stdio. ([#16970](https://github.com/pantsbuild/pants/pull/16970))

* Fix invalid field error message for parametrized fields. ([#16911](https://github.com/pantsbuild/pants/pull/16911))

* Fix venv re-population race. ([#16931](https://github.com/pantsbuild/pants/pull/16931))

* `wait` for killed nailgun processes. ([#16924](https://github.com/pantsbuild/pants/pull/16924))

* remove override of register_plugin_field ([#16919](https://github.com/pantsbuild/pants/pull/16919))

* Only request source roots for PEP-517 deps that belong on the syspath ([#16903](https://github.com/pantsbuild/pants/pull/16903))

* Upgrade `javaparser`, and use a permissive language level to support parsing more code ([#16896](https://github.com/pantsbuild/pants/pull/16896))

* docker: upgrade bollard crate for bug fix ([#16850](https://github.com/pantsbuild/pants/pull/16850))

* Preserve stdio when a local process times out. ([#16841](https://github.com/pantsbuild/pants/pull/16841))

### Performance

* Add an optional speculation delay when using a remote cache ([#16922](https://github.com/pantsbuild/pants/pull/16922))

* Only use remote cache when cache scope is Always or Successful ([#16920](https://github.com/pantsbuild/pants/pull/16920))

### Documentation

* Fix Helm K8S parser help message ([#17091](https://github.com/pantsbuild/pants/pull/17091))

* Update `pytest-xdist` docs. ([#17071](https://github.com/pantsbuild/pants/pull/17071))

* Fix the [python-bootstrap].search_path option name in the docs. ([#17063](https://github.com/pantsbuild/pants/pull/17063))

* Add Doron Somech's proudest contribution ([#17029](https://github.com/pantsbuild/pants/pull/17029))

* improve remote cache logging for hit or miss ([#16975](https://github.com/pantsbuild/pants/pull/16975))

* Remove bad linebreaks from python-run-goal page. ([#16976](https://github.com/pantsbuild/pants/pull/16976))

* Update changelog on docsite with 2.13, 2.14 links ([#16918](https://github.com/pantsbuild/pants/pull/16918))

* Add Marcelo to team page, move Josh Reed to Maintainer ([#16826](https://github.com/pantsbuild/pants/pull/16826))

* Don't mention a specific version in the manual install instructions. ([#16888](https://github.com/pantsbuild/pants/pull/16888))

## 2.15.0.dev2 (Sep 09, 2022)

### New Features

* Force colors from mypy always, strip in pants when --no-colors ([#16586](https://github.com/pantsbuild/pants/pull/16586))

* Add OpenAPI backend ([#16199](https://github.com/pantsbuild/pants/pull/16199))

* go: analyze imports paths by module to enable multiple `go_mod` targets ([#16386](https://github.com/pantsbuild/pants/pull/16386))

### Bug fixes

* docker: capture output once after container exits ([#16783](https://github.com/pantsbuild/pants/pull/16783))

* docker: lazily initialize docker connection ([#16779](https://github.com/pantsbuild/pants/pull/16779))

### Documentation

* Add IBM, Coinbase, and Astranis case studies ([#16805](https://github.com/pantsbuild/pants/pull/16805))

* Fix broken shortlinks that invoked "docs:" instead of "doc:" ([#16804](https://github.com/pantsbuild/pants/pull/16804))

* Add Brand24 to user list. ([#16793](https://github.com/pantsbuild/pants/pull/16793))

## 2.15.0.dev1 (Sep 04, 2022)

### New Features

* go: support placing resource files in packages (and not just embedding) ([#16688](https://github.com/pantsbuild/pants/pull/16688))

* "naive" docker command runner ([#16670](https://github.com/pantsbuild/pants/pull/16670))

* Adds `binary_name` field to PyOxidizer support ([#16696](https://github.com/pantsbuild/pants/pull/16696))

### Plugin API Changes

* The environment to use becomes a context-specific parameter ([#16721](https://github.com/pantsbuild/pants/pull/16721))

* Deprecate `Platform.current` in favor of requesting an injected `Platform` ([#16765](https://github.com/pantsbuild/pants/pull/16765))

* Allow `@union`s to declare additional types which are provided to implementers ([#16717](https://github.com/pantsbuild/pants/pull/16717))

* Deprecate remote_auth_plugin option - plugins can use entry points now. ([#16691](https://github.com/pantsbuild/pants/pull/16691))

### Bug fixes

* Add support for inferring dependencies used in type context bounds ([#16709](https://github.com/pantsbuild/pants/pull/16709))

* Resolve properly provided symbol names for types defined at top level package ([#16690](https://github.com/pantsbuild/pants/pull/16690))

* Include type bound constraints in consumed symbols during Scala inference ([#16692](https://github.com/pantsbuild/pants/pull/16692))

* Make experimental_shell_command deterministic ([#16675](https://github.com/pantsbuild/pants/pull/16675))

### Documentation

* List commercial Pants services that optionally supplement community's extensive free tier ([#16706](https://github.com/pantsbuild/pants/pull/16706))

* In python resource example, use importlib.resources to read assets ([#16695](https://github.com/pantsbuild/pants/pull/16695))

* Welcome community members to consider joining team ([#16681](https://github.com/pantsbuild/pants/pull/16681))

## 2.15.0.dev0 (Aug 29, 2022)

### New Features

* Add support for string interpolation in Helm deployments ([#16611](https://github.com/pantsbuild/pants/pull/16611))

* Add --squash and --pull options support for docker build ([#16607](https://github.com/pantsbuild/pants/pull/16607))

* Support Pex's `--path-mapping` with lockfiles for better local requirement support ([#16584](https://github.com/pantsbuild/pants/pull/16584))

* [experimental] adds `pants_oxidized_experimental` target, creating a standalone binary distribution for Pants ([#16484](https://github.com/pantsbuild/pants/pull/16484))

### User API Changes

* Remove deprecated `[python].only_binary`, `[python].no_binary`, and `[python].tailor_ignore_solitary_init_files` ([#16638](https://github.com/pantsbuild/pants/pull/16638))

* Remove deprecated `[python].lockfile_generator` and deprecate `poetry` subsystem (used previously for lockfile generation) ([#16633](https://github.com/pantsbuild/pants/pull/16633))

* Remove deprecated `use_deprecated_directory_cli_args_semantics` option ([#16630](https://github.com/pantsbuild/pants/pull/16630))

### Plugin API Changes

* Add support for passing multiple input params to a `@rule` `Get` ([#16668](https://github.com/pantsbuild/pants/pull/16668))

* Remove deprecated `matches_filespec` and `get_git` functions ([#16629](https://github.com/pantsbuild/pants/pull/16629))

* Remove unnecessary type parameter from `Get` ([#16634](https://github.com/pantsbuild/pants/pull/16634))

### Bug fixes

* Fix dirtying of uncacheable nodes ([#17079](https://github.com/pantsbuild/pants/pull/17079))

* Make `FilespecMatcher` case-sensitive ([#16673](https://github.com/pantsbuild/pants/pull/16673))

* Ensure the sandbox distdir exists when creating dists via PEP517. ([#16647](https://github.com/pantsbuild/pants/pull/16647))

### Performance

* Implement a batched local lookup for missing fingerprints. ([#16627](https://github.com/pantsbuild/pants/pull/16627))

* Optimize `CreateDigest` implementation. ([#16617](https://github.com/pantsbuild/pants/pull/16617))

### Documentation

* Create page of Pants team members and proudest contribs ([#16676](https://github.com/pantsbuild/pants/pull/16676))

* Fix example BSP groups file. ([#16649](https://github.com/pantsbuild/pants/pull/16649))

* Clarify wording for `--skip` options ([#16622](https://github.com/pantsbuild/pants/pull/16622))

* Fix `./pants help` docs on command line specs ([#16616](https://github.com/pantsbuild/pants/pull/16616))

* Mention team meetings as a Contributor permission ([#16543](https://github.com/pantsbuild/pants/pull/16543))
